
// preamble  //{

var c y d yh yf yhhome yhs  // goods (7)
	kM hM eM  				// market (10)
	kD hD eD  				// domestic good (13)
	rer 					// exchange rates (14)
	w zk mc  				// factor prices and cost (18)
	pH dp dpH 				// good prices (21)
	iM iD R Rs 	    		// intertemporal optimization (25)
	lb qM qD 				// Lagrangians (28)
	Del Dels 				// Price Distribution change in ER (30)
	bf CA					// international sector (32)
	C KM KD z pHn pHd en inv // helpers (38)	inv

	// disturbances
	 aM ze g zeta_DF zeta_In zeta_MP dps ys  zeta_DFs//(46)  
	
	; 

predetermined_variables kM kD;
 	
varexo   epaM epze epg epDF epIn epMP epdps epys 
		 epDFs  // ep_rer 
		;



parameters	gammaC rhoC gammay rhoy  	// good aggregation
			betta csi siggma nu 			// utility function
			xi	theta					// Price setting (without theta)
			
			alphaM rhoM omegaeM omegakM // market sector
			alphaD rhoD omegaeD omegakD	// household production sector
			phiKM phiKD delta  			// capital markets
			bfss chi 						// Foreign Bonds, FB Adjustment Cost
			
			// Monetary Policy Rule
			rhoR phi_dp phi_y phi_q		// Smoothing and Policy params
			dpbar ybar Rbar	Rss	Rsss		// means
			
	
			ysss  		// sample means
			 
			
			// Disturbances (aM, aD, ze, g, DF, In, MP, dps, ys)
			raM sigaM aMss
			aDss 
			rze theta_ze sigze zess
			rg sigg gss
			rDF sigDF zeta_DFss
			rIn sigIn zeta_Inss
			sigMP
			rdps sigdps dpsss
			rys sigys
			 rDFs sigDFs
			; 
/* // adding aD
var aD;
parameters raD sigaD;
varexo epaD;
*/

// Observation equations
// adding yobs, dpobs
var yobs; varexo ep_yobs;
parameters mu_y sig_yobs;
var dpobs; varexo ep_dpobs;
parameters mu_dp sig_dpobs;

// adding Robs, Rsobs
var Robs;
parameters mu_R;
var Rsobs;
parameters mu_Rs;

//adding drerobs
var drerobs; varexo ep_drerobs;
parameters mu_drer sig_drerobs;

// adding gobs
var gobs;
parameters mu_g;

// adding zeobs 
var  zeobs; 
parameters  mu_ze;

// adding enobs
var enobs; varexo ep_enobs;
parameters mu_en sig_enobs;

//adding invobs
var invobs; varexo ep_invobs;
parameters mu_inv sig_invobs;

varobs yobs invobs gobs dpobs Robs drerobs  zeobs enobs Rsobs ;
//}

// Estimated Parameters Initialization //{

rhoC=0.8; 
rhoy=1.5;
siggma=0.66;

sigma_s =siggma;
nu=1;
theta=10;
xi =0.75;
rhoM=0.6; 
rhoD=0.6; 

// Monetary Policy
rhoR=0.5; phi_dp=1.5; phi_y=0.125; phi_q=0;

// Disturbances
raM=0.9;  rg=0.9;  //raD=0.9; 
rDF=0.9; rIn = 0.9;  rDFs=0.9; rdps=0.9; rys=0.9;

sigaM=0.09;  sigg=0.09; //sigaD=0.09;
sigDF=0.09; sigIn=0.09; sigMP=0.09; 
sigdps=0.09; sigys=0.09; sigDFs=0.09;

// From separate Estimation
rze=0.58; theta_ze=0.42; sigze=0.0918;

steady;
//}

model; //{	

// model local vars
# psiC  = (rhoC-1)/rhoC;
# psiM  = (rhoM-1)/rhoM;
# psiD  = (rhoD-1)/rhoD;
# psiy  = (rhoy-1)/rhoy;



# h   = log(exp(hM) + exp(hD));


//derivatives (model local variables)
# dudh  = log(csi) + nu*h;
# dudC  = zeta_DF - C /siggma;
# dCdc  = (log(1-gammaC) + C - c)/rhoC; 
# dCdd  = (log(gammaC) +C - d)/rhoC;
# dddhD = log(1-alphaD) + d - hD;
# dddeD = log(alphaD) + log(omegaeD) + d - KD + (KD - eD)/rhoD;
# dudC_p1  = zeta_DF(+1)-C(+1) /siggma;
# dCdd_p1  = (log(gammaC) +C(+1) - d(+1))/rhoC;
# dddkD_p1 = log(alphaD*omegakD) + d(+1) - KD(+1) + (KD(+1) - kD(+1))/rhoD;

exp(en) = exp(eM)+exp(eD);
exp(inv) =exp(iM) + exp(iD);



// Good Aggregation
exp(C*psiC) = ((1-gammaC)^(1-psiC) * exp(c*psiC) + gammaC^(1-psiC)*exp(d*psiC)); //(1)

//y=((1-gammay)^(1-psiy)*yhhome^psiy+gammay^(1-psiy)*yf^psiy)^(1/psiy); (skipped)

// Production
Del+yh=aM+alphaM*KM+(1-alphaM)*hM;
exp(KM*psiM) = (omegakM * exp(kM * psiM) + omegaeM * exp(eM *psiM)); //(3)

d   = log(aDss)+aM + alphaD*KD + (1-alphaD)* hD; //(3)
exp(KD*psiD) = (omegakD * exp(kD * psiD) + omegaeD * exp(eD *psiD)); //(5)

// Intratemporal Choice
lb   = dudC + dCdc;
dudh + zeta_DF = lb + w; //(7)
dudh + zeta_DF = dudC + dCdd +dddhD;
dudC + dCdd + dddeD = ze + lb; //(9)

//Lomocs
exp(kM(+1))=exp(zeta_In +iM)-phiKM/2*(exp(zeta_In+iM-kM) - delta)^2 * exp(kM) + (1-delta) * exp(kM);
exp(kD(+1))=exp(zeta_In +iD)-phiKD/2*(exp(zeta_In+iD-kD) - delta)^2 * exp(kD) + (1-delta) * exp(kD); //(11)

exp(qM) = betta *(exp(lb(+1)+zk(+1)) + exp(qM(+1)) * (1-delta+phiKM/2*(exp(zeta_In(+1)+iM(+1)-kM(+1))^2-delta^2))); 
exp(qD) = betta *(exp(dudC_p1+dCdd_p1+dddkD_p1) + exp(qD(+1)) * (1-delta+phiKD/2*(exp(zeta_In(+1)+iD(+1)-kD(+1))^2-delta^2))); //(13)

exp(lb) = exp(qM) * (exp(zeta_In)-phiKM*(exp(zeta_In+iM-kM)-delta)); 
exp(lb) = exp(qD) * (exp(zeta_In)-phiKD*(exp(zeta_In+iD-kD)-delta)); //(15)

//Saving
exp(lb) = betta * exp(R +lb(+1) - dp(+1));
exp(lb) * (1+chi*bf) = betta * exp(Rs+lb(+1)+Dels(+1) - dp(+1)); //(17)

// Good Demand
yhhome = log(1-gammay)-rhoy*pH+y;
yf = log(gammay)+y-rhoy*rer; //(19)
yhs =log(gammay)+ys-rhoy*(pH-rer);

// factor prices
ze = z +log(omegaeM)+(KM-eM)/rhoM; //(21)
zk = z +log(omegakM)+(KM-kM)/rhoM; 

w  = mc + log(1-alphaM)+Del+yh-hM; //(23)
z  = mc + log(alphaM)+Del+yh-KM; 

//price setting
exp(pHn) = theta/(theta-1)*exp(lb+theta*pH+mc+yh) + betta*xi*exp(pHn(+1)+theta*dp(+1)); //(25)
exp(pHd) = exp(lb+theta*pH+yh)+betta*xi*exp(pHd(+1)+(theta-1)*dp(+1)); 
exp((1-theta)*pH) = (1-xi)*exp((1-theta)*(pHn-pHd))+ xi*exp((1-theta)*pH(-1)-dp); //(27)
exp(Del) = (1-xi)*exp(-theta*(pHn-pHd-pH)) + xi * exp(theta*dpH+Del(-1)); 

// prices
1  = (1-gammay)*exp(pH*(1-rhoy))+gammay * exp(rer*(1-rhoy)); //(29)
pH = dpH-dp+pH(-1); 
rer = rer(-1)+Dels+dps-dp; //(31)

//international sector
CA = bf - exp(Rs(-1)+Dels-dp)*bf(-1);
Rs+log(betta) +zeta_DFs= dps(+1)+(ys(+1)-ys)/siggma;//33 +zeta_DFs


// market clearing
exp(yh) = exp(yhhome) + exp(yhs); 
exp(y)=exp(c)+exp(inv)+exp(g)+exp(ze+en)+chi/2*bf^2; //35
exp(pH+yh)=exp(y)+CA; //35

// interest rate rule
R=rhoR*R(-1)+(1-rhoR)*(log(Rss)+phi_dp*(dp-steady_state(dp))+phi_y*(y-steady_state(y)) + phi_q*rer)+zeta_MP; //(37)


// Disturbances
aM   = raM * aM(-1)    + (1-raM)  * log(aMss)   + epaM; 
//aD  = raD* aD(-1)    + (1-raD)  * log(aDss)   + epaD;
ze  = rze * ze(-1)  + (1-rze)*log(zess) + epze    + theta_ze*(epze(-1)); //39
dps   = rdps * dps(-1)  + (1-rdps)*log(dpsss) + epdps;
ys   = rys * ys(-1)  + (1-rys)*log(ysss) + epys; //41
g    = rg  *g(-1)       + (1-rg)   * log(gss)    + epg; 
zeta_DF  = rDF  * zeta_DF(-1)   +  epDF; //43
zeta_In  = rIn  * zeta_In(-1)   + (1-rIn)  * log(zeta_Inss) + epIn;
zeta_MP  = epMP; //45

zeta_DFs = rDFs * zeta_DFs(-1) + epDFs;


// Observation equations
yobs    - mu_y    = 100 * (y - y(-1)) +ep_yobs ;// 47
dpobs   - mu_dp   = 400 * dp + ep_dpobs;
Robs              = 400 * R; // 49
Rsobs   - mu_Rs + mu_R = 400 * Rs; 
drerobs - mu_drer  = rer - rer(-1) + ep_drerobs; // 51
zeobs   - mu_ze    = ze - ze(-1);
enobs   - mu_en    = en - en(-1)  + ep_enobs; // 53
gobs    - mu_g     = g - g(-1);
invobs  - mu_inv   = inv - inv(-1)+ep_invobs;

end; //}

shocks; //{
var epaM; stderr sigaM;
// dvar epaD; stderr sigaD;
var epze; stderr sigze;
var epg; stderr sigg;
var epDF; stderr sigDF;
var epIn; stderr sigIn;
var epMP; stderr sigMP; 
var epdps; stderr sigdps;
var epys; stderr sigys;
var epDFs; stderr sigDFs;

var ep_yobs; stderr sig_yobs;
var ep_dpobs; stderr sig_dpobs;

var ep_drerobs; stderr sig_drerobs;
var ep_enobs; stderr sig_enobs;
var ep_invobs; stderr sig_invobs;
//var ep_rer; stderr 1;
end; //}

check;
stoch_simul(relative_irf, order=1, irf=20, nomoments, irf_shocks=(epMP), irf_plot_threshold =0)y R dp yhs yf Dels dp rer;
model_diagnostics;
model_info;
check(solve_algo=4);

estimated_params; //{
// Param, shape: [beta_pdf gamma_pdf inv_gamma_pdf], mean, stderr;
/*
rhoC, gamma_pdf, 0.8, 0.2;
rhoy, gamma_pdf, 0.8, 0.2;
siggma, gamma_pdf, 0.66, 0.1;
nu, gamma_pdf, 1, 0.3;
theta, gamma_pdf, 10, 2;
xi, beta_pdf, 0.75, 0.1;
rhoM, gamma_pdf, 0.4, 0.15;
rhoD, gamma_pdf, 0.4, 0.15;


phi_dp, gamma_pdf, 1.5, 0.05;
phi_y, gamma_pdf, 0.125, 0.1;
*/
rhoR, beta_pdf, 0.6, 0.25;
raM, beta_pdf, 0.9, 0.1;
//raD, beta_pdf, 0.9, 0.1;
rze, beta_pdf, 0.58, 0.1;
theta_ze, beta_pdf, 0.9, 0.1;
rg, beta_pdf, 0.9, 0.1;
rDF, beta_pdf, 0.9, 0.1;
rIn, beta_pdf, 0.9, 0.1;
rdps, 0.9, beta_pdf, 0.5, 0.2;
rys, 0.9, beta_pdf, 0.5, 0.2;
rDFs, beta_pdf, 0.9, 0.1;

stderr epaM, inv_gamma_pdf, 0.15, 5;
//stderr epaD, inv_gamma_pdf, 0.15, 5;
stderr epze, inv_gamma_pdf, 0.15, 5;
stderr epg, inv_gamma_pdf, 0.15, 5;
stderr epDF, inv_gamma_pdf, 0.15, 5;
stderr epIn, inv_gamma_pdf, 0.15, 5;
stderr epMP, inv_gamma_pdf, 0.15, 5;
stderr epdps, inv_gamma_pdf, 0.15, 5;
stderr epys, inv_gamma_pdf, 0.15, 5;
//stderr epDFs, inv_gamma_pdf, 0.15, 5;
end; //}

estimated_params_init(use_calibration);
end;

//identification(parameter_set = prior_mean);
estimation(datafile='simuldata.mat', 
	prefilter=0, 
	mh_replic = 0, 
	mh_nblocks = 5,  // default==2
	mh_jscale = 0.2, 
	mode_compute = 4,
	plot_priors = 0,
	mode_check) y c R dp hM hD;


