function [ysteady,check] = main_steadystate(ysteady,exe)
global M_ lgy_

if isfield(M_,'param_nbr') == 1
NumberOfParameters = M_.param_nbr;
for i = 1:NumberOfParameters
  paramname = deblank(M_.param_names(i,:));
  eval([ paramname ' = M_.params(' int2str(i) ');']);
end
check = 0;
end

%% Model dependent part

% Calibration (Swiss Data)
gammaC=0.5; 
gammay=0.6;
phiKM=1; phiKD=1; 
delta=0.025;
chi=0.01; %#ok<*NASGU>
% xi=0.3;

% Calibration (Swiss Data)
hDss=0.242;
hMss=0.207;
labor_share = 0.675;
energy_share=0.03;

kDsy = 7.211;
gsy=0.2;

%From seperate estimation:
%     rze=0.58; theta_ze=0.42; sigma_ze=0.0918; % mistake of all mistakes?!

load('samplemeans.mat'); %produced by getdata_est.m
zess=exp(mu_ze);
mze=log(zess);



% rhoR = 0;

sig_yobs=0.05; sig_dpobs=0.05; sig_ysobs=0.05; sig_dpsobs=0.05;
sig_drerobs=0.05; sig_enobs=0.05; sig_invobs=0.1;

%% Steady State (as documented in Appendix xx in the Thesis)

% Normalizing model disturbances
aMss=1; zeta_DFss=1; zeta_Inss=1; zeta_MPss=1; 
zeta_DFsss=1;

%Inflation/exchange rate variables normalized to 1
dpHss=1; dpss=1; Delss=1; Delsss=1; 
pHss=1; psss=1;

% steady state is symmetric across countries
rerss=1;
bfss=0; CAss=0;

Rss = exp(mu_R/400);
mRs =log(Rss);
% Rss = 1+(mu_R/400);
Rsss=Rss;
betta = dpss/Rss;
mcss=(theta-1)/theta;

% For Brevity
psiM=(rhoM-1)/rhoM;
psiC=((rhoC-1)/rhoC); 
psiD=(rhoD-1)/rhoD;
psiy = (rhoy-1)/rhoy;

% Market Production
alphaM=1-labor_share/mcss;
omegaMtilde=energy_share/(mcss*alphaM);

zkss = (1-betta*(1-delta))/betta;


eMsy=alphaM*mcss/zess*omegaMtilde;
kMsy=alphaM*mcss/zkss*(1-omegaMtilde);

omegaeM = omegaMtilde*eMsy^(-psiM);
omegakM = (1-omegaMtilde)*kMsy^(-psiM);

KMsy=(omegakM*kMsy^psiM+omegaeM*eMsy^psiM)^(1/psiM); %=1

yhss = KMsy^(alphaM/(1-alphaM))*hMss;
yss = yhss;
ysss = yss;
wss=mcss*(1-alphaM)*yss/hMss;

zss=(omegaeM^rhoM*zess^(1-rhoM)+omegakM^rhoM*zkss^(1-rhoM))^(1/(1-rhoM));

% Household Production
eDsy = 0.79*eMsy;

omegaDtilde = zess*eDsy/(zess*eDsy+zkss*kDsy);

omegaeD = omegaDtilde*eDsy^(-psiD);
omegakD = (1-omegaDtilde)*kDsy^(-psiD);

helper_alphaD = hDss/hMss*(1-alphaM)*(1-omegaDtilde)*mcss/(zkss*kDsy);
alphaD = 1/(1+helper_alphaD);

KDsy=(omegakD*kDsy^psiD+omegaeD*eDsy^psiD)^(1/psiD);

sh_en=zess * (eMsy+eDsy);
sh_en_s=sh_en;
% Government
gss=gsy*yss;

csy = 1 - gsy - delta*(kMsy+kDsy) - sh_en;
css=csy*yss;

dss = (wss*hDss*(gammaC*css/(1-gammaC))^(-1/rhoC)/(1-alphaD))^(1/psiC);
dsstilde=((hDss/yss)^(1-alphaD)*KDsy^(alphaD))*yss;
aDss=dss/dsstilde;

 mys=log(yss);
yhhomess = (1-gammay)*yss;
yfss=gammay*yss;
yhsss=gammay*exp(mys);

eMss=eMsy*yss; eDss=eDsy*yss;
kMss=kMsy*yss; kDss=kDsy*yss;
iMss=delta*kMss; iDss=delta*kDss;
invss=iMss+iDss;
KDss=KDsy*yss; KMss=KMsy*yss;

Css=((1-gammaC)^(1/rhoC)*css^psiC+ gammaC^(1/rhoC)*dss^psiC)^(1/psiC);

dudCss=Css^(-1/siggma);
dCdcss=Css^(1/rhoC) * (1-gammaC)^(1/rhoC)*css^((-1)/(rhoC));
dCddss=Css^(1/rhoC) * gammaC^(1/rhoC)*dss^((-1)/(rhoC));
dddkDss=alphaD*dss/KDss * KDss^(1/(rhoD))*omegakD*kDss^(-1/rhoD);
dddeDss=alphaD*dss/KDss * KDss^(1/(rhoD))*omegaeD*eDss^(-1/rhoD);
dddhDss=(1-alphaD)*dss/hDss;

csi= dudCss*dCddss*dddhDss/(hDss+hMss)^nu;
dudhss = csi*(hMss+hDss)^nu;

lbss=dudCss*dCdcss;
qMss=lbss;
qDss=lbss;

pHdss=lbss*pHss^theta*yhss/(1-betta*xi*dpss^theta); 
pHnss=lbss*pHss^theta*yhss/(1-betta*xi*dpss^(1-theta));

% Steady States used as model parameters
Rbar=Rss; dpbar=dpss; ybar=yss; dpsss=1;

enss=eMss+eDss;
esss=enss;

%% former initval section  


bf=bfss;
CA=CAss;

c      = log(css);
y      = log(yss);
d      = log(dss);
yh     = log(yhss);
yf     = log(yfss);
yhhome = log(yhhomess);
yhs    = log(yhsss);

kM=log(kMss);  hM=log(hMss);  eM=log(eMss);
kD=log(kDss);  hD=log(hDss);  eD=log(eDss); 

rer = log(rerss);

w   = log(wss);
zk  = log(zkss);
mc  = log(mcss);

pH  = log(pHss);
dp  = log(dpss);
dpH = log(dpHss);

iM = log(iMss);
iD = log(iDss);
R  = log(Rss);
Rs = log(Rsss);

lb = log(lbss);
qM = log(qMss);
qD = log(qDss);

Del  = log(Delss); 
Dels = log(Delsss);

C   = log(Css);
KM  = log(KMss); 
KD  = log(KDss);
z   = log(zss);
pHn = log(pHnss);
pHd = log(pHdss);

dps = log(dpsss); %]]]
% Disturbances
aM      = log(aMss);
aD      = log(aDss);
ze      = log(zess);
g       = log(gss);
zeta_DF = log(zeta_DFss);
zeta_In = log(zeta_Inss);
zeta_MP = log(zeta_MPss);
ps      = log(dpsss);
ys      = log(ysss);
zeta_DFs= log(zeta_DFsss);

yobs   = mu_y;
dpobs  = mu_dp;
Robs   = mu_R;

Rsobs  = mu_Rs;
drerobs = mu_drer;
% dpHobs = mu_dpH;
gobs = mu_g;
zeobs = mu_ze;


enobs = mu_en;
invobs = mu_inv;
en = log(enss);
inv = log(invss);
zep_rer=0;
ner=0;
%% Model Independent Part
for iter = 1:length(M_.params)
  eval([ 'M_.params(' num2str(iter) ') = ' M_.param_names(iter,:) ';' ])
end

if isfield(M_,'param_nbr') == 1
    if isfield(M_,'orig_endo_nbr') == 1
        NumberOfEndogenousVariables = M_.orig_endo_nbr;
    else
        NumberOfEndogenousVariables = M_.endo_nbr;
    end
    ysteady = zeros(NumberOfEndogenousVariables,1);
    for i = 1:NumberOfEndogenousVariables
        varname = deblank(M_.endo_names(i,:));
        eval(['ysteady(' int2str(i) ') = ' varname ';' ]);
    end
else
    ysteady=zeros(length(lgy_),1);
    for i = 1:length(lgy_)
        ysteady(i) = eval(lgy_(i,:));
    end
    check = 0;
end
end



